pro addproduct,filename,colorimage,sds_name,xparameter,productname,fail,quick = quick

;*************************************************************************
; Modification history:
;  11/08/2001
;    Initial Release.
;
; Credits:
;  Written by Eric G. Moody and Mark Gray.
;  eric.moody@gsfc.nasa.gov
;  gray@climate.gsfc.nasa.gov
;  Climate and Radiation Branch
;  NASA Goddard Space Flight Center
;  Greenbelt, Maryland, U.S.A.
;
; License:
; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.
;
; Permission is granted to anyone to use this software and to alter
; it freely, subject to the following restrictions:
;
; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software.
;
; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.
;
; 3. This notice may not be removed or altered from any source distribution.
;*************************************************************************

fail=0

lat_sdsname='Latitude'
long_sdsname='Longitude'

get_modis_data,filename,sds_name,latitude,longitude,sds_data,fail1,datarange

if fail1 ne 1 then begin

bad=where((sds_data le 0),badcount)

if badcount gt 0 then sds_data(bad)=0.

array_size_temp=size(sds_data)

xsize=array_size_temp(1)
ysize=array_size_temp(2)

if keyword_set(quick) then colorproductmap,sds_data,$
                                         latitude,$
                                         longitude,$
                                         colorimage,$
                                         datarange,$
                                         xparameter,$
                                         /validrange,$
                                         /dilateno
if not keyword_set(quick) then colorproductmap,sds_data,$
                                         latitude,$
                                         longitude,$
                                         colorimage,$
                                         datarange,$
                                         xparameter,$
                                         /validrange
sds_data=0
latitude=0
longitude=0

endif else begin
  print,'no data here'
  fail=1
endelse
end
