pro RemapTileData,Image,Lat,Lon,ns,nl,xparameter,UniqueChannels,maxmin,channels,newimage,logscale=logscale

dummy=size(Image)

data_xsize=dummy[1]
data_ysize=dummy[2]


dummy=size(UniqueChannels)

if dummy[0] eq 1 then NumberofChannels=dummy[1]
if dummy[0] eq 0 then NumberofChannels=1

imin=fltarr(NumberofChannels)
imax=fltarr(NumberofChannels)

imin[0:NumberofChannels-1]=maxmin[1,*]
imax[0:NumberofChannels-1]=maxmin[0,*]

Bimage=byte(image)

;byte scale image 

if keyword_set(logscale) then begin
 imagezero=where(image eq 0,count)
 image=alog(image)
 if count gt 0 then image(imagezero)=0.
 ;imin=alog(imin)
 imax=alog(imax)
endif


for channelloop=0,NumberofChannels-1 do begin
  image[*,*,channelloop:channelloop]=$
         bytscl( image[*,*,channelloop:channelloop],$
                 min = imin[channelloop],$
                 max = imax[channelloop],$
                 top = !d.table_size - 2 ) +1B
endfor

image=byte(image)
dummy=size(image)
iiend=dummy[1]
jjend=dummy[2]

;lets get our rgbs out now to save work later
if NumberofChannels gt 3 then begin
; it's super plot!  well, that is we combine the brightest values of the
; 1 4 3 and 7 6 1 rgb combintations to try and get a nice looking rgb that
; shows land and cloud features clearly
   
   red_index1=where(UniqueChannels eq channels(0))
   green_index1=where(UniqueChannels eq channels(1))
   blue_index1=where(UniqueChannels eq channels(2))


   red_index2=where(UniqueChannels eq channels(3))
   green_index2=where(UniqueChannels eq channels(4))
   blue_index2=where(UniqueChannels eq channels(5))
    

   imagetemp=bytarr(iiend,jjend,3)
   screenblend,channeltemp,image[*,*,red_index1],image[*,*,red_index2]
   imagetemp[*,*,0]=channeltemp
   screenblend,channeltemp,image[*,*,green_index1],image[*,*,green_index2]
   imagetemp[*,*,1]=channeltemp
   screenblend,channeltemp,image[*,*,blue_index1],image[*,*,blue_index2]
   imagetemp[*,*,2]=channeltemp
   image=imagetemp
   NumberofChannels=3

endif

if NumberofChannels eq 3 then begin
   red_index=where(UniqueChannels eq channels(0),foundcount)
   if foundcount gt 1 then red_index=0
   green_index=where(UniqueChannels eq channels(1),foundcount)
   if foundcount gt 1 then green_index=1
   blue_index=where(UniqueChannels eq channels(2),foundcount)
   if foundcount gt 1 then blue_index=2

   imagetemp=bytarr(iiend,jjend,3)
   imagetemp[*,*,0]=image[*,*,red_index]
   imagetemp[*,*,1]=image[*,*,green_index]
   imagetemp[*,*,2]=image[*,*,blue_index]
   image=imagetemp
endif

if NumberofChannels eq 1 then begin
   imagetemp=bytarr(iiend,jjend,3)
   imagetemp[*,*,0]=image[*,*]
   imagetemp[*,*,1]=image[*,*]
   imagetemp[*,*,2]=image[*,*]
   image=imagetemp
endif

;remove bad latitude points from remapping
if min(lat) lt -90. then begin
  badlat=where(lat lt -90.,count)
  if count gt 0 then lat(badlat)=0.
  if count gt 0 then lon(badlat)=0.
end

;fix problem when one saturated channels makes the rgb screwup

dummy=size(lat)
p = convert_coord( lon, lat, /data, /to_normal )

;p0=reform(p[0,*],dummy[1],dummy[2])
;p1=reform(p[1,*],dummy[1],dummy[2])
;
;p0 = rebin(p0,data_xsize,data_ysize)
;p1 = rebin(p1,data_xsize,data_ysize)

;p0 = reform(p0,1,data_xsize*data_ysize)
;p1 = reform(p1,1,data_xsize*data_ysize)
newimage=bytarr(ns,nl,NumberofChannels)
for channelloop=0,NumberofChannels-1 do begin
   temp=replicate(0B,ns,nl)
   temp[ p[ 0, * ] * ( ns - 1 ), p[ 1, * ] * ( nl - 1 ) ] = image[*,*,channelloop]

;   temp[ p0 * (ns - 1), p1 * (ns - 1) ] =  image[*,*,channelloop]

   newimage[*,*,channelloop]=temp
endfor

temp=0
p=0
image=0

x = !x.window * ns
y = !y.window * nl
newimage = temporary( newimage( x(0):x(1), y(0):y(1),* ) )

;- )compute image offset and size (device coordinates)
p = convert_coord( [ x(0), x(1) ] / float( ns ), [ y(0), y(1) ] / float( nl ), $
  /normal, /to_device )

xoffset = p(0,0)
yoffset = p(1,0)
xsize = p(0,1) - p(0,0)
ysize = p(1,1) - p(1,0)

;- display resampled image
arraysizetemp=size(newimage_0)
;outputimage=bytarr(arraysizetemp(1),arraysizetemp(2),3)

xparameter=intarr(4)
xparameter(0)= xoffset
xparameter(1)= yoffset
xparameter(2)= xsize
xparameter(3) =ysize
end
